Index: code/trunk/src/core/input/InputInterfaces.h
===================================================================
--- code/trunk/src/core/input/InputInterfaces.h	(revision 1881)
+++ code/trunk/src/core/input/InputInterfaces.h	(revision 1887)
@@ -47,6 +47,8 @@
     namespace KeyCode
     {
+        const unsigned int numberOfKeys = 0xEE; // 238
+
         // note: KeyCode comments were directly copied from OISKeyboard.h
-        enum Enum
+        enum ByEnum
         {
             Unassigned    = OIS::KC_UNASSIGNED,
@@ -119,6 +121,6 @@
             F9            = OIS::KC_F9,
             F10           = OIS::KC_F10,
-            Numlock       = OIS::KC_NUMLOCK,
-            Scrolllock    = OIS::KC_SCROLL,          // Scroll Lock
+            NumLock       = OIS::KC_NUMLOCK,
+            ScrollLock    = OIS::KC_SCROLL,          // Scroll Lock
             Numpad7       = OIS::KC_NUMPAD7,
             Numpad8       = OIS::KC_NUMPAD8,
@@ -167,5 +169,5 @@
             NumpadComma   = OIS::KC_NUMPADCOMMA,     // , on numeric keypad (NEC PC98)
             Divide        = OIS::KC_DIVIDE,          // / on numeric keypad
-            SYSRQ         = OIS::KC_SYSRQ,
+            SystemRequest = OIS::KC_SYSRQ,
             RightAlt      = OIS::KC_RMENU,           // right Alt
             Pause         = OIS::KC_PAUSE,           // Pause
@@ -196,9 +198,110 @@
             MediaSelect   = OIS::KC_MEDIASELECT      // Media Select
         };
-    }
-
-    namespace MouseButton
-    {
-        enum Enum
+        
+        // Names as string. Has no real linkage!
+        const char* const ByString[] =
+        {
+            "Unassigned",
+            "Escape",
+            "NumRow1", "NumRow2", "NumRow3", "NumRow4", "NumRow5",
+            "NumRow6", "NumRow7", "NumRow8", "NumRow9", "NumRow0",
+            "Minus", "Equals", "Back", "Tab",
+            "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P",
+            "LeftBracket", "RightBracket",
+            "Return", "LeftControl",
+            "A", "S", "D", "F", "G", "H", "J", "K", "L",
+            "Semicolon", "Apostrophe", "Grave",
+            "LeftShift", "Backslash",
+            "Z", "X", "C", "V", "B", "N", "M",
+            "Comma", "Period", "Slash",
+            "RightShift",
+            "Multiply",
+            "LeftAlt",
+            "Space",
+            "CapsLock",
+            "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10",
+            "NumLock", "ScrollLock",
+            "Numpad7", "Numpad8", "Numpad9",
+            "NumpadSubtract",
+            "Numpad4", "Numpad5", "Numpad6",
+            "NumpadAdd",
+            "Numpad1", "Numpad2", "Numpad3", "Numpad0",
+            "NumpadPeriod",
+            "","",
+            "LessThan",
+            "F11", "F12",
+            "","","","","","","","","","","",
+            "F13", "F14", "F15",
+            "","","","","","","","","","",
+            "Kana",
+            "","",
+            "ABNT_C1",
+            "","","","","",
+            "Convert",
+            "",
+            "NoConvert",
+            "",
+            "Yen",
+            "ABNT_C2",
+            "","","","","","","","","","","","","","",
+            "NumpadEquals",
+            "","",
+            "PreviousTrack",
+            "AT",
+            "Colon", "Underline",
+            "Kanji",
+            "Stop",
+            "AX",
+            "Unlabeled",
+            "NextTrack",
+            "","",
+            "NumpadEnter",
+            "RightControl",
+            "","",
+            "Mute",
+            "Calculator",
+            "PlayPause",
+            "",
+            "MediaStop",
+            "","","","","","","","","",
+            "VolumeDown",
+            "",
+            "VolumeUp",
+            "",
+            "WebHome",
+            "NumpadComma",
+            "",
+            "Divide",
+            "",
+            "SystemRequest",
+            "RightAlt",
+            "","","","","","","","","","","","",
+            "Pause",
+            "",
+            "Home",
+            "UP",
+            "PageUp",
+            "",
+            "Left",
+            "",
+            "Right",
+            "",
+            "End", "Down", "PageDown", "Insert", "Delete",
+            "","","","","","","",
+            "LeftWindows", "RightWindows", "Apps",
+            "Power", "Sleep",
+            "","","",
+            "Wake",
+            "",
+            "WebSearch", "WebFavorites", "WebRefresh", "WebStop", "WebForward", "WebBack",
+            "MyComputer", "Mail", "MediaSelect"
+        };
+    }
+
+    namespace MouseButtonCode
+    {
+        const unsigned int numberOfButtons = 8;
+
+        enum ByEnum
         {
             Left    = OIS::MB_Left,
@@ -209,11 +312,44 @@
             Button5 = OIS::MB_Button5,
             Button6 = OIS::MB_Button6,
-            Button7 = OIS::MB_Button7
-        };
-    }
-
-    namespace JoyStickButton
-    {
-        enum Enum
+            Button7 = OIS::MB_Button7,
+        };
+
+        // Names as string. Has no real linkage!
+        const char* const ByString[] =
+        {
+            "Left",
+            "Right",
+            "Middle",
+            "Button3",
+            "Button4",
+            "Button5",
+            "Button6",
+            "Button7",
+        };
+    }
+
+    namespace MouseAxisCode
+    {
+        const unsigned int numberOfAxes = 2;
+
+        enum ByEnum
+        {
+            X,
+            Y
+        };
+
+        // Names as string. Has no real linkage!
+        const char* const ByString[] =
+        {
+            "X",
+            "Y"
+        };
+    }
+
+    namespace JoyStickButtonCode
+    {
+        const unsigned int numberOfButtons = 64;
+
+        enum ByEnum
         {
             Button0       =  0, Button1       =  1, Button2       =  2, Button3       =  3,
@@ -238,4 +374,51 @@
             POV3NorthEast = 60, POV3SouthEast = 61, POV3NorthWest = 62, POV3SouthWest = 63,
         };
+
+        // Names as string. Has no real linkage!
+        const char* const ByString[] =
+        {
+            "Button0",       "Button1",       "Button2",       "Button3",
+            "Button4",       "Button5",       "Button6",       "Button7",
+            "Button8",       "Button9",       "Button10",      "Button11",
+            "Button12",      "Button13",      "Button14",      "Button15",
+            "Button16",      "Button17",      "Button18",      "Button19",
+            "Button20",      "Button21",      "Button22",      "Button23",
+            "Button24",      "Button25",      "Button26",      "Button27",
+            "Button28",      "Button29",      "Button30",      "Button31",
+            "POV0North",     "POV0South",     "POV0East",      "POV0West",
+            "POV0NorthEast", "POV0SouthEast", "POV0NorthWest", "POV0SouthWest",
+            "POV1North",     "POV1South",     "POV1East",      "POV1West",
+            "POV1NorthEast", "POV1SouthEast", "POV1NorthWest", "POV1SouthWest",
+            "POV2North",     "POV2South",     "POV2East",      "POV2West",
+            "POV2NorthEast", "POV2SouthEast", "POV2NorthWest", "POV2SouthWest",
+            "POV3North",     "POV3South",     "POV3East",      "POV3West",
+            "POV3NorthEast", "POV3SouthEast", "POV3NorthWest", "POV3SouthWest"
+        };
+    }
+
+    namespace JoyStickAxisCode
+    {
+        const unsigned int numberOfAxes = 24;
+
+        enum ByEnum
+        {
+            Slider0 =  0, Slider1 =  1, Slider2 =  2, Slider3 =  3,
+            Slider4 =  4, Slider5 =  5, Slider6 =  6, Slider7 =  7,
+            Axis0   =  8, Axis1   =  9, Axis2   = 10, Axis3   = 11,
+            Axis4   = 12, Axis5   = 13, Axis6   = 14, Axis7   = 15,
+            Axis8   = 16, Axis9   = 17, Axis10  = 18, Axis11  = 19,
+            Axis12  = 20, Axis13  = 21, Axis14  = 22, Axis15  = 23
+        };
+
+        // Names as string. Has no real linkage!
+        const char* const ByString[] =
+        {
+            "Slider0", "Slider1", "Slider2", "Slider3",
+            "Slider4", "Slider5", "Slider6", "Slider7",
+            "Axis0",   "Axis1",   "Axis2",   "Axis3",
+            "Axis4",   "Axis5",   "Axis6",   "Axis7",
+            "Axis8",   "Axis9",   "Axis10",  "Axis11",
+            "Axis12",  "Axis13",  "Axis14",  "Axis15"
+        };
     }
 
@@ -259,5 +442,5 @@
             JoyStick1,
             JoyStick2,
-            JoyStick3,
+            JoyStick3
             // note: No problem if there are more joy sticks. This enum is just for convenience.
         };
@@ -266,6 +449,6 @@
     struct _CoreExport Key
     {
-        Key(const OIS::KeyEvent& evt) : key((KeyCode::Enum)evt.key), text(evt.text) { }
-        KeyCode::Enum key;
+        Key(const OIS::KeyEvent& evt) : key((KeyCode::ByEnum)evt.key), text(evt.text) { }
+        KeyCode::ByEnum key;
         unsigned int text;
     };
@@ -274,12 +457,12 @@
     {
     public:
-        KeyEvent(KeyCode::Enum key, unsigned int text) : key(key), text(text) { }
+        KeyEvent(KeyCode::ByEnum key, unsigned int text) : key(key), text(text) { }
         KeyEvent(const OIS::KeyEvent& evt, unsigned int mod)
-            : key((KeyCode::Enum)evt.key), text(evt.text), modifiers(mod) { }
+            : key((KeyCode::ByEnum)evt.key), text(evt.text), modifiers(mod) { }
         KeyEvent(const Key& key, unsigned int mod) : key(key.key), text(key.text), modifiers(mod) { }
         bool isModifierDown(KeyboardModifier::Enum modifier) const
             { return (KeyboardModifier::Enum)modifier&modifiers; }
 
-        const KeyCode::Enum key;
+        const KeyCode::ByEnum key;
         unsigned int text;
         unsigned int modifiers;
@@ -316,7 +499,7 @@
     public:
         virtual ~MouseHandler() { }
-        virtual void mouseButtonPressed (MouseButton::Enum id) = 0;
-        virtual void mouseButtonReleased(MouseButton::Enum id) = 0;
-        virtual void mouseButtonHeld    (MouseButton::Enum id) = 0;
+        virtual void mouseButtonPressed (MouseButtonCode::ByEnum id) = 0;
+        virtual void mouseButtonReleased(MouseButtonCode::ByEnum id) = 0;
+        virtual void mouseButtonHeld    (MouseButtonCode::ByEnum id) = 0;
         virtual void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) = 0;
         virtual void mouseScrolled      (int abs, int rel)     = 0;
@@ -333,7 +516,7 @@
     public:
         virtual ~JoyStickHandler() { }
-        virtual void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id) = 0;
-        virtual void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id) = 0;
-        virtual void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id) = 0;
+        virtual void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
+        virtual void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
+        virtual void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
         virtual void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value) = 0;
         virtual void tickJoyStick          (float dt, unsigned int joyStick) = 0;
@@ -357,13 +540,13 @@
         void keyHeld    (const KeyEvent& evt) { }
 
-        void mouseButtonPressed (MouseButton::Enum id) { }
-        void mouseButtonReleased(MouseButton::Enum id) { }
-        void mouseButtonHeld    (MouseButton::Enum id) { }
+        void mouseButtonPressed (MouseButtonCode::ByEnum id) { }
+        void mouseButtonReleased(MouseButtonCode::ByEnum id) { }
+        void mouseButtonHeld    (MouseButtonCode::ByEnum id) { }
         void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) { }
         void mouseScrolled      (int abs, int rel) { }
 
-        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id) { }
-        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id) { }
-        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id) { }
+        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) { }
+        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id) { }
+        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) { }
         void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value) { }
     };
Index: code/trunk/src/core/input/InputManager.cc
===================================================================
--- code/trunk/src/core/input/InputManager.cc	(revision 1881)
+++ code/trunk/src/core/input/InputManager.cc	(revision 1887)
@@ -56,9 +56,8 @@
 #include "SimpleInputState.h"
 #include "ExtendedInputState.h"
+#include "JoyStickDeviceNumberListener.h"
 
 namespace orxonox
 {
-    SetConsoleCommand(InputManager, keyBind, true);
-    SetConsoleCommand(InputManager, storeKeyStroke, true);
     SetConsoleCommand(InputManager, calibrate, true);
     SetConsoleCommand(InputManager, reload, false);
@@ -165,4 +164,6 @@
             if (joyStickSupport)
                 _initialiseJoySticks();
+            // Do this anyway to also inform everyone if a joystick was detached.
+            _configureNumberOfJoySticks();
 
             // Set mouse/joystick region
@@ -197,9 +198,9 @@
             stateMaster_ = new ExtendedInputState();
             stateMaster_->setName("master");
+            stateMaster_->setNumOfJoySticks(joySticksSize_);
 
             // KeyDetector to evaluate a pressed key's name
             SimpleInputState* detector = createInputState<SimpleInputState>("detector", 101);
             keyDetector_ = new KeyDetector();
-            keyDetector_->loadBindings("storeKeyStroke");
             detector->setHandler(keyDetector_);
 
@@ -320,5 +321,4 @@
             //CCOUT(ORX_WARNING) << "Warning: Joy stick support requested, but no joy stick was found" << std::endl;
         }
-        _redimensionLists();
     }
 
@@ -331,5 +331,5 @@
         occupy 2 places in the device number dependent lists.
     */
-    void InputManager::_redimensionLists()
+    void InputManager::_configureNumberOfJoySticks()
     {
         joySticksSize_ = joySticks_.size();
@@ -357,5 +357,15 @@
         for (std::map<int, InputState*>::const_iterator it = inputStatesByPriority_.begin();
             it != inputStatesByPriority_.end(); ++it)
+        {
             it->second->setNumOfJoySticks(joySticksSize_);
+        }
+        // inform master state
+        if (stateMaster_)
+            this->stateMaster_->setNumOfJoySticks(joySticksSize_);
+
+        // inform all JoyStick Device Number Listeners
+        for (ObjectList<JoyStickDeviceNumberListener>::iterator it = ObjectList<JoyStickDeviceNumberListener>::begin(); it; ++it)
+            it->JoyStickDeviceNumberChanged(joySticksSize_);
+
     }
 
@@ -385,5 +395,5 @@
             if (!cont)
             {
-                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), "CoeffPos", coeffPos);
+                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), getIdentifier()->getName(), "CoeffPos", coeffPos);
                 getIdentifier()->addConfigValueContainer("CoeffPos", cont);
             }
@@ -393,5 +403,5 @@
             if (!cont)
             {
-                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), "CoeffNeg", coeffNeg);
+                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), getIdentifier()->getName(), "CoeffNeg", coeffNeg);
                 getIdentifier()->addConfigValueContainer("CoeffNeg", cont);
             }
@@ -401,5 +411,5 @@
             if (!cont)
             {
-                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), "Zero", zero);
+                cont = new ConfigValueContainer(CFT_Settings, getIdentifier(), getIdentifier()->getName(), "Zero", zero);
                 getIdentifier()->addConfigValueContainer("Zero", cont);
             }
@@ -515,7 +525,7 @@
 
             joySticks_.clear();
-            // don't use _redimensionLists(), might mess with registered handler if
+            // don't use _configureNumberOfJoySticks(), might mess with registered handler if
             // downgrading from 2 to 1 joystick
-            //_redimensionLists();
+            //_configureNumberOfJoySticks();
             joySticksSize_ = 0;
         }
@@ -875,5 +885,5 @@
         // check whether the key already is in the list (can happen when focus was lost)
         unsigned int iKey = 0;
-        while (iKey < keysDown_.size() && keysDown_[iKey].key != (KeyCode::Enum)e.key)
+        while (iKey < keysDown_.size() && keysDown_[iKey].key != (KeyCode::ByEnum)e.key)
             iKey++;
         if (iKey == keysDown_.size())
@@ -912,5 +922,5 @@
         for (unsigned int iKey = 0; iKey < keysDown_.size(); iKey++)
         {
-            if (keysDown_[iKey].key == (KeyCode::Enum)e.key)
+            if (keysDown_[iKey].key == (KeyCode::ByEnum)e.key)
             {
                 keysDown_.erase(keysDown_.begin() + iKey);
@@ -977,11 +987,11 @@
         // check whether the button already is in the list (can happen when focus was lost)
         unsigned int iButton = 0;
-        while (iButton < mouseButtonsDown_.size() && mouseButtonsDown_[iButton] != (MouseButton::Enum)id)
+        while (iButton < mouseButtonsDown_.size() && mouseButtonsDown_[iButton] != (MouseButtonCode::ByEnum)id)
             iButton++;
         if (iButton == mouseButtonsDown_.size())
-            mouseButtonsDown_.push_back((MouseButton::Enum)id);
-
-        activeStatesTop_[Mouse]->mouseButtonPressed((MouseButton::Enum)id);
-        stateMaster_->mouseButtonPressed((MouseButton::Enum)id);
+            mouseButtonsDown_.push_back((MouseButtonCode::ByEnum)id);
+
+        activeStatesTop_[Mouse]->mouseButtonPressed((MouseButtonCode::ByEnum)id);
+        stateMaster_->mouseButtonPressed((MouseButtonCode::ByEnum)id);
 
         return true;
@@ -1001,5 +1011,5 @@
         for (unsigned int iButton = 0; iButton < mouseButtonsDown_.size(); iButton++)
         {
-            if (mouseButtonsDown_[iButton] == (MouseButton::Enum)id)
+            if (mouseButtonsDown_[iButton] == (MouseButtonCode::ByEnum)id)
             {
                 mouseButtonsDown_.erase(mouseButtonsDown_.begin() + iButton);
@@ -1008,6 +1018,6 @@
         }
 
-        activeStatesTop_[Mouse]->mouseButtonReleased((MouseButton::Enum)id);
-        stateMaster_->mouseButtonReleased((MouseButton::Enum)id);
+        activeStatesTop_[Mouse]->mouseButtonReleased((MouseButtonCode::ByEnum)id);
+        stateMaster_->mouseButtonReleased((MouseButtonCode::ByEnum)id);
 
         return true;
@@ -1038,13 +1048,13 @@
 
         // check whether the button already is in the list (can happen when focus was lost)
-        std::vector<JoyStickButton::Enum>& buttonsDown = joyStickButtonsDown_[iJoyStick];
+        std::vector<JoyStickButtonCode::ByEnum>& buttonsDown = joyStickButtonsDown_[iJoyStick];
         unsigned int iButton = 0;
         while (iButton < buttonsDown.size() && buttonsDown[iButton] != button)
             iButton++;
         if (iButton == buttonsDown.size())
-            buttonsDown.push_back((JoyStickButton::Enum)button);
-
-        activeStatesTop_[2 + iJoyStick]->joyStickButtonPressed(iJoyStick, (JoyStickButton::Enum)button);
-        stateMaster_->joyStickButtonPressed(iJoyStick, (JoyStickButton::Enum)button);
+            buttonsDown.push_back((JoyStickButtonCode::ByEnum)button);
+
+        activeStatesTop_[2 + iJoyStick]->joyStickButtonPressed(iJoyStick, (JoyStickButtonCode::ByEnum)button);
+        stateMaster_->joyStickButtonPressed(iJoyStick, (JoyStickButtonCode::ByEnum)button);
 
         return true;
@@ -1056,5 +1066,5 @@
 
         // remove the button from the joyStickButtonsDown_ list
-        std::vector<JoyStickButton::Enum>& buttonsDown = joyStickButtonsDown_[iJoyStick];
+        std::vector<JoyStickButtonCode::ByEnum>& buttonsDown = joyStickButtonsDown_[iJoyStick];
         for (unsigned int iButton = 0; iButton < buttonsDown.size(); iButton++)
         {
@@ -1066,6 +1076,6 @@
         }
 
-        activeStatesTop_[2 + iJoyStick]->joyStickButtonReleased(iJoyStick, (JoyStickButton::Enum)button);
-        stateMaster_->joyStickButtonReleased(iJoyStick, (JoyStickButton::Enum)button);
+        activeStatesTop_[2 + iJoyStick]->joyStickButtonReleased(iJoyStick, (JoyStickButtonCode::ByEnum)button);
+        stateMaster_->joyStickButtonReleased(iJoyStick, (JoyStickButtonCode::ByEnum)button);
 
         return true;
@@ -1177,4 +1187,14 @@
     }
 
+    /**
+    @brief
+        Sets the the name of the command used by the KeyDetector as callback.
+    @param command
+        Command name as string
+    */
+    void InputManager::setKeyDetectorCallback(const std::string& command)
+    {
+        this->keyDetector_->setCallbackCommand(command);
+    }
 
     // ###### InputStates ######
@@ -1356,35 +1376,4 @@
     /**
     @brief
-        Method for easily storing a string with the command executor. It is used by the
-        KeyDetector to get assign commands. The KeyDetector simply executes
-        the command 'storeKeyStroke myName' for each button/axis.
-    @remarks
-        This is only a temporary hack until we thourouhgly support multiple KeyBinders.
-    @param name
-        The name of the button/axis.
-    */
-    void InputManager::storeKeyStroke(const std::string& name)
-    {
-        getInstance().requestLeaveState("detector");
-        COUT(0) << "Binding string \"" << bindingCommmandString_s << "\" on key '" << name << "'" << std::endl;
-        CommandExecutor::execute("config KeyBinder " + name + " " + bindingCommmandString_s, false);
-    }
-
-    /**
-    @brief
-        Assigns a command string to a key/button/axis. The name is determined via KeyDetector
-        and InputManager::storeKeyStroke(.).
-    @param command
-        Command string that can be executed by the CommandExecutor
-    */
-    void InputManager::keyBind(const std::string& command)
-    {
-        bindingCommmandString_s = command;
-        getInstance().requestEnterState("detector");
-        COUT(0) << "Press any button/key or move a mouse/joystick axis" << std::endl;
-    }
-
-    /**
-    @brief
         Starts joy stick calibration.
     */
Index: code/trunk/src/core/input/InputManager.h
===================================================================
--- code/trunk/src/core/input/InputManager.h	(revision 1881)
+++ code/trunk/src/core/input/InputManager.h	(revision 1887)
@@ -110,9 +110,10 @@
         void clearBuffers();
 
-        int  numberOfKeyboards() { return keyboard_ ? 1 : 0; }
-        int  numberOfMice()      { return mouse_    ? 1 : 0; }
-        int  numberOfJoySticks() { return joySticksSize_; }
+        unsigned int  numberOfKeyboards() { return keyboard_ ? 1 : 0; }
+        unsigned int  numberOfMice()      { return mouse_    ? 1 : 0; }
+        unsigned int  numberOfJoySticks() { return joySticksSize_; }
 
         void setWindowExtents(const int width, const int height);
+        void setKeyDetectorCallback(const std::string& command);
 
         template <class T>
@@ -132,6 +133,4 @@
 
         // console commands
-        static void storeKeyStroke(const std::string& name);
-        static void keyBind(const std::string& command);
         static void calibrate();
         static void reload(bool joyStickSupport = true);
@@ -148,5 +147,5 @@
         void _initialiseMouse();
         void _initialiseJoySticks();
-        void _redimensionLists();
+        void _configureNumberOfJoySticks();
 
         void _destroyKeyboard();
@@ -223,6 +222,6 @@
 
         std::vector<Key>                    keysDown_;
-        std::vector<MouseButton::Enum>      mouseButtonsDown_;
-        std::vector<std::vector<JoyStickButton::Enum> >  joyStickButtonsDown_;
+        std::vector<MouseButtonCode::ByEnum>      mouseButtonsDown_;
+        std::vector<std::vector<JoyStickButtonCode::ByEnum> >  joyStickButtonsDown_;
 
         static std::string                  bindingCommmandString_s;
Index: code/trunk/src/core/input/InputState.h
===================================================================
--- code/trunk/src/core/input/InputState.h	(revision 1881)
+++ code/trunk/src/core/input/InputState.h	(revision 1887)
@@ -78,13 +78,13 @@
         virtual void keyHeld    (const KeyEvent& evt) = 0;
 
-        virtual void mouseButtonPressed (MouseButton::Enum id) = 0;
-        virtual void mouseButtonReleased(MouseButton::Enum id) = 0;
-        virtual void mouseButtonHeld    (MouseButton::Enum id) = 0;
+        virtual void mouseButtonPressed (MouseButtonCode::ByEnum id) = 0;
+        virtual void mouseButtonReleased(MouseButtonCode::ByEnum id) = 0;
+        virtual void mouseButtonHeld    (MouseButtonCode::ByEnum id) = 0;
         virtual void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) = 0;
         virtual void mouseScrolled      (int abs, int rel) = 0;
 
-        virtual void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id) = 0;
-        virtual void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id) = 0;
-        virtual void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id) = 0;
+        virtual void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
+        virtual void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
+        virtual void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
         virtual void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value) = 0;
 
Index: code/trunk/src/core/input/JoyStickDeviceNumberListener.cc
===================================================================
--- code/trunk/src/core/input/JoyStickDeviceNumberListener.cc	(revision 1887)
+++ code/trunk/src/core/input/JoyStickDeviceNumberListener.cc	(revision 1887)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Implementation of the JoyStickDeviceNumberListener class.
+*/
+
+#include "JoyStickDeviceNumberListener.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    JoyStickDeviceNumberListener::JoyStickDeviceNumberListener()
+    {
+        RegisterObject(JoyStickDeviceNumberListener);
+    }
+}
Index: code/trunk/src/core/input/JoyStickDeviceNumberListener.h
===================================================================
--- code/trunk/src/core/input/JoyStickDeviceNumberListener.h	(revision 1887)
+++ code/trunk/src/core/input/JoyStickDeviceNumberListener.h	(revision 1887)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief 
+*/
+
+#ifndef _JoyStickDeviceNumberListener_H__
+#define _JoyStickDeviceNumberListener_H__
+
+#include "core/CorePrereqs.h"
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    class _CoreExport JoyStickDeviceNumberListener : virtual public OrxonoxClass
+    {
+    public:
+        JoyStickDeviceNumberListener();
+        virtual ~JoyStickDeviceNumberListener() { }
+
+        virtual void JoyStickDeviceNumberChanged(unsigned int value) = 0;
+    };
+}
+
+#endif /* _JoyStickDeviceNumberListener_H__ */
